# Program 0 #

In case you've spent some time in a 1-indexed like Matlab, remember that we
start counting from 0 in C++.

This problem will give you a taste of working with C++ compiler errors.
Open the file `problem0.cpp` and read it.

* * * *

## Question 0 ##
<div class=question><!-- P0, Q0 -->

**Without compiling the program, find an error in the code and explain why 
it's an error.**
</div>
<div class=answer> 

<!-- FIXME: Your answer goes here -->
</div>

* * * *

## Question 1 ##

First, compile the program with `g++`. The command for this is `g++ program0.cpp`.

You might notice that the compiler gives you no output, in spite of the fact
that this program *clearly* has errors. This is because `g++` is set, by default,
to use a very conservative set of error checks. This can be changed by using
compiler flags. We are going to use `-Wall` which turns on some warnings, and
`-Wextra`, which turns on some more. In spite of their names, neither
flag actually enables all warnings.

Recompile the program by using the `-Wall` and `-Wextra` flags in the compiler
command.

* * * *

<div class=question><!-- P0, Q1 -->

**When compiling with `-Wall -Wextra`, there should be three warnings that
are printed. Pick two warnings and explain what they are trying to say**.
</div>
<div class=answer>

<!-- FIXME: Your answer goes here -->
</div>

* * * *

## Question 2 ##

<div class=question><!-- P0, Q2 -->

**Fix `program0.cpp` so that no warnings or errors are emitted when compiling
using `-Wall -Wextra`. The functions should do what their names say.**
</div>
<div class=answer>
<!-- FIXME: No answer is needed, but make sure to change problem0.cpp -->
</div>

* * * *

While it's hard to imagine making these kinds of silly errors in a program this
small, in large C++ codebases (like the `GCC` compiler, which is over 5 million
lines), these kinds of errors can easily slip past. Therefore, *you should
always make it a point to compile with warnings turned on*. Later projects will
have build systems that automate this for you, but if you ever work on your
own C++ projects, for you own sanity, remember to turn these flags on.
